unit AES_Client;

interface

uses
  System.SysUtils, System.Classes, System.StrUtils, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, WEBLib.WebSocketClient, JS,
  WEBLib.Controls, WEBLib.ExtCtrls, WEBLib.Crypto, Types, Web;

type
  TForm1 = class(TWebForm)
    WebButton1: TWebButton;
    enc: TWebEdit;
    result: TWebEdit;
    procedure WebFormCreate(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
  private
    { Private declarations }
    aesGCM: TAESEncryption;
    procedure CryptoKeyCreated(Sender: TObject);
    procedure MessageEncrypted(ADataAsArrayBuffer: TJSArrayBuffer);
    procedure CryptoError(AError: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  KEY_FIRST = '{"alg":"A128CBC","ext":true,"k":"CQ4H9zufO9lxBhec","key_ops":["encrypt","decrypt"],"kty":"oct"}';

implementation

{$R *.dfm}

procedure TForm1.CryptoKeyCreated(Sender: TObject);
begin
  aesGCM.ImportKey(KEY_FIRST);
end;

procedure TForm1.MessageEncrypted(ADataAsArrayBuffer: TJSArrayBuffer);
var
  s: string;
begin
  s := ABToBinaryString(ADataAsArrayBuffer);
//  WebSocketClient1.Send(s);
  result.text := s;
end;

procedure TForm1.CryptoError(AError: string);
begin
  if ContainsText(AError, 'OperationError') then
  begin
    ShowMessage('A message has arrived. Decoding was unsuccessful with the selected key.<br>');
  end;
end;

procedure TForm1.WebButton1Click(Sender: TObject);
begin
  aesGCM.Encrypt(enc.Text);
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  aesGCM := TAESEncryption.Create(aetCBC);
  aesGCM.OnKeyCreated := CryptoKeyCreated; //Change key to a predefined one when class is ready
  aesGCM.OnEncrypted := MessageEncrypted;
  aesGCM.OnError := CryptoError;
end;

end.